#include <iostream>

#include "GWt_elementLigneFaiseau.h"
#include "GWt_ligneFaisceau.h"
#include "GWt_drift.h"
#include "GWt_rfgun.h"
#include "GWt_cell.h"
#include "GWt_soleno.h"
#include "GWt_bend.h"
#include "GWt_dialog.h"

#include "mixedTools.h"

#include <Wt/WVBoxLayout>


GWt_LigneFaisceau::GWt_LigneFaisceau(PspaApplication* ps) :
  WContainerWidget(),
  pspa_(ps),
  nObjets_(NULL)
{

  cout<<"GWt_LigneFaisceau::GWt_LigneFaisceau() %d"<< this << "<---------------"<< endl;

  ligneFaisceauLayout_ = new WHBoxLayout();
  //  decorationStyle().setBackgroundColor (WColor(245,245,245)); 
  decorationStyle().setBackgroundImage (WApplication::appRoot()+"/htdocs/background.png");
  setLayout(ligneFaisceauLayout_);

  int nElts= nomdElements::getNumberOfElements(); 
  nObjets_= new Compteur[nElts];

  // set the object name 
  setObjectName("ligneFaisceau");

  // add the first drop zone
  ligneFaisceauLayout_->addWidget(new GWt_elementLigneFaiseau());

    // add a last element to push everything
    ligneFaisceauLayout_->addWidget(new WText("") , 1,Wt::AlignMiddle);


  // add a strech element at the end
  //  ligneFaisceauLayout_->addStretch(1);
}
 

    
void GWt_LigneFaisceau::restoreElementCollection()
{

  cout<<"GWt_LigneFaisceau::restoreElementCollection()"<<endl;

  ligneFaisceauLayout_->clear();

  delete[] nObjets_;
  int nElements= nomdElements ::getNumberOfElements(); 
  nObjets_= new Compteur[nElements];

  int nbElem = pspa_->getDataManager()->beamLineSize();
  unsigned int k;

  // add first dropZone
  ligneFaisceauLayout_->addWidget(new GWt_elementLigneFaiseau());

  for(k = 0; k < (unsigned)nbElem; k++) 
    {
      abstractElement* ptr = pspa_->getDataManager()->getCollection()->getElementPointerFromIndex(k);
/*      GWt_abstractElement* gw = GWt_abstractElement::ajoute(ptr);
      if(gw == NULL) {
	cerr << "GWt_LigneFaisceau::restaure element type " << ptr->getNomdElement().getElementName() << " est inconnu " << endl;
      }
      gw->setLabelWidget();
 */
      nObjets_[ptr->getNomdElement().getElementType()].incr();
      GWt_elementLigneFaiseau* dropZone = new GWt_elementLigneFaiseau(ptr);

        /*      dropZone->addElement(gw->getWidget());
*/
        ligneFaisceauLayout_->addWidget(dropZone,0);

        
/*      if (k < ((unsigned)nbElem-1)) {
        ligneFaisceauLayout_->addWidget(new GWt_elementLigneFaiseau());
      } else {
        ligneFaisceauLayout_->addWidget(new GWt_elementLigneFaiseau());
      }
*/
    }

  pspa_->updateSelections();
}


void GWt_LigneFaisceau::addElement(typedElement eType){


  abstractElement* ptr = pspa_->getDataManager()->addElement(eType);

  if(eType == inconnu) {
    cout << "GWt_LigneFaisceau::element type " << eType << " inconnu " << endl;
    return;
  }


//  ligneFaisceauLayout_->addWidget(new GWt_elementLigneFaiseau(ptr),0);
  ligneFaisceauLayout_->insertWidget(ligneFaisceauLayout_->count()-1,new GWt_elementLigneFaiseau(ptr),0);
}

